diff --git a/stdlib.ispc b/stdlib.ispc
index 43e6ebd96..d4eec9ca3 100644
--- a/stdlib.ispc
+++ b/stdlib.ispc
@@ -711,25 +711,31 @@ __declspec(safe) static inline int64 count_trailing_zeros(int64 v) {
 // AOS/SOA conversion
 
 static inline void aos_to_soa2(uniform float a[], varying float *uniform v0, varying float *uniform v1) {
-    __aos_to_soa2_float(a, v0, v1);
+    __aos_to_soa2_float((uniform int8 * uniform) a, (uniform int8 * uniform) v0, (uniform int8 * uniform) v1);
 }
 
-static inline void soa_to_aos2(float v0, float v1, uniform float a[]) { __soa_to_aos2_float(v0, v1, a); }
+static inline void soa_to_aos2(float v0, float v1, uniform float a[]) {
+    __soa_to_aos2_float(v0, v1, (uniform int8 * uniform) a);
+}
 
 static inline void aos_to_soa3(uniform float a[], varying float *uniform v0, varying float *uniform v1,
                                varying float *uniform v2) {
-    __aos_to_soa3_float(a, v0, v1, v2);
+    __aos_to_soa3_float((uniform int8 * uniform) a, (uniform int8 * uniform) v0, (uniform int8 * uniform) v1,
+                        (uniform int8 * uniform) v2);
 }
 
-static inline void soa_to_aos3(float v0, float v1, float v2, uniform float a[]) { __soa_to_aos3_float(v0, v1, v2, a); }
+static inline void soa_to_aos3(float v0, float v1, float v2, uniform float a[]) {
+    __soa_to_aos3_float(v0, v1, v2, (uniform int8 * uniform) a);
+}
 
 static inline void aos_to_soa4(uniform float a[], varying float *uniform v0, varying float *uniform v1,
                                varying float *uniform v2, varying float *uniform v3) {
-    __aos_to_soa4_float(a, v0, v1, v2, v3);
+    __aos_to_soa4_float((uniform int8 * uniform) a, (uniform int8 * uniform) v0, (uniform int8 * uniform) v1,
+                        (uniform int8 * uniform) v2, (uniform int8 * uniform) v3);
 }
 
 static inline void soa_to_aos4(float v0, float v1, float v2, float v3, uniform float a[]) {
-    __soa_to_aos4_float(v0, v1, v2, v3, a);
+    __soa_to_aos4_float(v0, v1, v2, v3, (uniform int8 * uniform) a);
 }
 
 static inline void aos_to_soa2(uniform int32 a[], varying int32 *uniform v0, varying int32 *uniform v1) {
@@ -761,27 +767,31 @@ static inline void soa_to_aos4(int32 v0, int32 v1, int32 v2, int32 v3, uniform i
 }
 
 static inline void aos_to_soa2(uniform double a[], varying double *uniform v0, varying double *uniform v1) {
-    __aos_to_soa2_double(a, v0, v1);
+    __aos_to_soa2_double((uniform int8 * uniform) a, (uniform int8 * uniform) v0, (uniform int8 * uniform) v1);
 }
 
-static inline void soa_to_aos2(double v0, double v1, uniform double a[]) { __soa_to_aos2_double(v0, v1, a); }
+static inline void soa_to_aos2(double v0, double v1, uniform double a[]) {
+    __soa_to_aos2_double(v0, v1, (uniform int8 * uniform) a);
+}
 
 static inline void aos_to_soa3(uniform double a[], varying double *uniform v0, varying double *uniform v1,
                                varying double *uniform v2) {
-    __aos_to_soa3_double(a, v0, v1, v2);
+    __aos_to_soa3_double((uniform int8 * uniform) a, (uniform int8 * uniform) v0, (uniform int8 * uniform) v1,
+                         (uniform int8 * uniform) v2);
 }
 
 static inline void soa_to_aos3(double v0, double v1, double v2, uniform double a[]) {
-    __soa_to_aos3_double(v0, v1, v2, a);
+    __soa_to_aos3_double(v0, v1, v2, (uniform int8 * uniform) a);
 }
 
 static inline void aos_to_soa4(uniform double a[], varying double *uniform v0, varying double *uniform v1,
                                varying double *uniform v2, varying double *uniform v3) {
-    __aos_to_soa4_double(a, v0, v1, v2, v3);
+    __aos_to_soa4_double((uniform int8 * uniform) a, (uniform int8 * uniform) v0, (uniform int8 * uniform) v1,
+                         (uniform int8 * uniform) v2, (uniform int8 * uniform) v3);
 }
 
 static inline void soa_to_aos4(double v0, double v1, double v2, double v3, uniform double a[]) {
-    __soa_to_aos4_double(v0, v1, v2, v3, a);
+    __soa_to_aos4_double(v0, v1, v2, v3, (uniform int8 * uniform) a);
 }
 
 static inline void aos_to_soa2(uniform int64 a[], varying int64 *uniform v0, varying int64 *uniform v1) {
@@ -1113,11 +1123,11 @@ __declspec(safe) static inline uniform unsigned int64 reduce_max(unsigned int64
 
 #define REDUCE_EQUAL(TYPE, FUNCTYPE, MASKTYPE)                                                                         \
     __declspec(safe) static inline uniform bool reduce_equal(TYPE v) {                                                 \
-        uniform TYPE unusedValue;                                                                                      \
+        uniform int8 unusedValue;                                                                                      \
         return __reduce_equal_##FUNCTYPE(v, &unusedValue, (MASKTYPE)__mask);                                           \
     }                                                                                                                  \
     __declspec(safe) static inline uniform bool reduce_equal(TYPE v, uniform TYPE *uniform value) {                    \
-        return __reduce_equal_##FUNCTYPE(v, value, (MASKTYPE)__mask);                                                  \
+        return __reduce_equal_##FUNCTYPE(v, (uniform int8 * uniform) value, (MASKTYPE)__mask);                         \
     }
 
 REDUCE_EQUAL(float16, half, IntMaskType)
@@ -1166,257 +1176,257 @@ static unsigned int64 exclusive_scan_or(unsigned int64 v) { return __exclusive_s
 /* unsigned int32 implementations. */
 // unsigned int32 load.
 static inline uniform int packed_load_active(uniform unsigned int a[], varying unsigned int *uniform vals) {
-    return __packed_load_activei32(a, vals, (UIntMaskType)__mask);
+    return __packed_load_activei32((uniform int8 * uniform) a, (uniform int8 * uniform) vals, (UIntMaskType)__mask);
 }
 
 // unsigned int32 store.
 static inline uniform int packed_store_active(uniform unsigned int a[], unsigned int vals) {
-    return __packed_store_activei32(a, vals, (UIntMaskType)__mask);
+    return __packed_store_activei32((uniform int8 * uniform) a, vals, (UIntMaskType)__mask);
 }
 
 // unsigned int32 store2.
 static inline uniform int packed_store_active2(uniform unsigned int a[], unsigned int vals) {
-    return __packed_store_active2i32(a, vals, (UIntMaskType)__mask);
+    return __packed_store_active2i32((uniform int8 * uniform) a, vals, (UIntMaskType)__mask);
 }
 
 /* int32 implementations. */
 // int32 load.
 static inline uniform int packed_load_active(uniform int a[], varying int *uniform vals) {
-    return __packed_load_activei32(a, vals, (IntMaskType)__mask);
+    return __packed_load_activei32((uniform int8 * uniform) a, (uniform int8 * uniform) vals, (IntMaskType)__mask);
 }
 
 // int32 store.
 static inline uniform int packed_store_active(uniform int a[], int vals) {
-    return __packed_store_activei32(a, vals, (IntMaskType)__mask);
+    return __packed_store_activei32((uniform int8 * uniform) a, vals, (IntMaskType)__mask);
 }
 
 // int32 store2.
 static inline uniform int packed_store_active2(uniform int a[], int vals) {
-    return __packed_store_active2i32(a, vals, (IntMaskType)__mask);
+    return __packed_store_active2i32((uniform int8 * uniform) a, vals, (IntMaskType)__mask);
 }
 
 // int32 store with lanes.
 static inline uniform int packed_store_active(bool active, uniform int a[], int vals) {
-    return __packed_store_activei32(a, vals, (IntMaskType)(-(int)active));
+    return __packed_store_activei32((uniform int8 * uniform) a, vals, (IntMaskType)(-(int)active));
 }
 
 /* unsigned int64 implementations. */
 // unsigned int64 load.
 static inline uniform int packed_load_active(uniform unsigned int64 a[], varying unsigned int64 *uniform vals) {
-    return __packed_load_activei64(a, vals, (UIntMaskType)__mask);
+    return __packed_load_activei64((uniform int8 * uniform) a, (uniform int8 * uniform) vals, (UIntMaskType)__mask);
 }
 
 // unsigned int64 store.
 static inline uniform int packed_store_active(uniform unsigned int64 a[], unsigned int64 vals) {
-    return __packed_store_activei64(a, vals, (UIntMaskType)__mask);
+    return __packed_store_activei64((uniform int8 * uniform) a, vals, (UIntMaskType)__mask);
 }
 
 // unsigned int64 store2.
 static inline uniform int packed_store_active2(uniform unsigned int64 a[], unsigned int64 vals) {
-    return __packed_store_active2i64(a, vals, (UIntMaskType)__mask);
+    return __packed_store_active2i64((uniform int8 * uniform) a, vals, (UIntMaskType)__mask);
 }
 
 /* int64 implementations. */
 // int64 load.
 static inline uniform int packed_load_active(uniform int64 a[], varying int64 *uniform vals) {
-    return __packed_load_activei64(a, vals, (IntMaskType)__mask);
+    return __packed_load_activei64((uniform int8 * uniform) a, (uniform int8 * uniform) vals, (IntMaskType)__mask);
 }
 
 // int64 store.
 static inline uniform int packed_store_active(uniform int64 a[], int64 vals) {
-    return __packed_store_activei64(a, vals, (IntMaskType)__mask);
+    return __packed_store_activei64((uniform int8 * uniform) a, vals, (IntMaskType)__mask);
 }
 
 // int64 store2.
 static inline uniform int packed_store_active2(uniform int64 a[], int64 vals) {
-    return __packed_store_active2i64(a, vals, (IntMaskType)__mask);
+    return __packed_store_active2i64((uniform int8 * uniform) a, vals, (IntMaskType)__mask);
 }
 
 // int64 store with lanes.
 static inline uniform int packed_store_active(bool active, uniform int64 a[], int64 vals) {
-    return __packed_store_activei64(a, vals, (IntMaskType)(-(int)active));
+    return __packed_store_activei64((uniform int8 * uniform) a, vals, (IntMaskType)(-(int)active));
 }
 
 ///////////////////////////////////////////////////////////////////////////
 // streaming store
 
 __declspec(safe, cost1) static inline void streaming_store(uniform unsigned int8 a[], unsigned int8 vals) {
-    __streaming_store_varying_i8(a, vals);
+    __streaming_store_varying_i8((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform int8 a[], int8 vals) {
-    __streaming_store_varying_i8(a, vals);
+    __streaming_store_varying_i8((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform unsigned int16 a[], unsigned int16 vals) {
-    __streaming_store_varying_i16(a, vals);
+    __streaming_store_varying_i16((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform int16 a[], int16 vals) {
-    __streaming_store_varying_i16(a, vals);
+    __streaming_store_varying_i16((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform float16 a[], float16 vals) {
-    __streaming_store_varying_half(a, vals);
+    __streaming_store_varying_half((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform unsigned int a[], unsigned int vals) {
-    __streaming_store_varying_i32(a, vals);
+    __streaming_store_varying_i32((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform int a[], int vals) {
-    __streaming_store_varying_i32(a, vals);
+    __streaming_store_varying_i32((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform unsigned int64 a[], unsigned int64 vals) {
-    __streaming_store_varying_i64(a, vals);
+    __streaming_store_varying_i64((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform int64 a[], int64 vals) {
-    __streaming_store_varying_i64(a, vals);
+    __streaming_store_varying_i64((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform float a[], float vals) {
-    __streaming_store_varying_float(a, vals);
+    __streaming_store_varying_float((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform double a[], double vals) {
-    __streaming_store_varying_double(a, vals);
+    __streaming_store_varying_double((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform unsigned int8 a[], uniform unsigned int8 vals) {
-    __streaming_store_uniform_i8(a, vals);
+    __streaming_store_uniform_i8((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform int8 a[], uniform int8 vals) {
-    __streaming_store_uniform_i8(a, vals);
+    __streaming_store_uniform_i8((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform unsigned int16 a[], uniform unsigned int16 vals) {
-    __streaming_store_uniform_i16(a, vals);
+    __streaming_store_uniform_i16((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform int16 a[], uniform int16 vals) {
-    __streaming_store_uniform_i16(a, vals);
+    __streaming_store_uniform_i16((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform float16 a[], uniform float16 vals) {
-    __streaming_store_uniform_half(a, vals);
+    __streaming_store_uniform_half((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform unsigned int a[], uniform unsigned int vals) {
-    __streaming_store_uniform_i32(a, vals);
+    __streaming_store_uniform_i32((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform int a[], uniform int vals) {
-    __streaming_store_uniform_i32(a, vals);
+    __streaming_store_uniform_i32((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform unsigned int64 a[], uniform unsigned int64 vals) {
-    __streaming_store_uniform_i64(a, vals);
+    __streaming_store_uniform_i64((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform int64 a[], uniform int64 vals) {
-    __streaming_store_uniform_i64(a, vals);
+    __streaming_store_uniform_i64((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform float a[], uniform float vals) {
-    __streaming_store_uniform_float(a, vals);
+    __streaming_store_uniform_float((uniform int8 * uniform) a, vals);
 }
 
 __declspec(safe, cost1) static inline void streaming_store(uniform double a[], uniform double vals) {
-    __streaming_store_uniform_double(a, vals);
+    __streaming_store_uniform_double((uniform int8 * uniform) a, vals);
 }
 
 ///////////////////////////////////////////////////////////////////////////
 // streaming load
 
 __declspec(safe, cost1) static inline varying unsigned int8 streaming_load(uniform unsigned int8 a[]) {
-    return (unsigned int8)__streaming_load_varying_i8(a);
+    return (unsigned int8)__streaming_load_varying_i8((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying int8 streaming_load(uniform int8 a[]) {
-    return __streaming_load_varying_i8(a);
+    return __streaming_load_varying_i8((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform unsigned int8 streaming_load_uniform(uniform unsigned int8 a[]) {
-    return (unsigned int8)__streaming_load_uniform_i8(a);
+    return (unsigned int8)__streaming_load_uniform_i8((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform int8 streaming_load_uniform(uniform int8 a[]) {
-    return __streaming_load_uniform_i8(a);
+    return __streaming_load_uniform_i8((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying unsigned int16 streaming_load(uniform unsigned int16 a[]) {
-    return (unsigned int16)__streaming_load_varying_i16(a);
+    return (unsigned int16)__streaming_load_varying_i16((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying int16 streaming_load(uniform int16 a[]) {
-    return __streaming_load_varying_i16(a);
+    return __streaming_load_varying_i16((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform unsigned int16 streaming_load_uniform(uniform unsigned int16 a[]) {
-    return (unsigned int16)__streaming_load_uniform_i16(a);
+    return (unsigned int16)__streaming_load_uniform_i16((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform int16 streaming_load_uniform(uniform int16 a[]) {
-    return __streaming_load_uniform_i16(a);
+    return __streaming_load_uniform_i16((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying float16 streaming_load(uniform float16 a[]) {
-    return __streaming_load_varying_half(a);
+    return __streaming_load_varying_half((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform float16 streaming_load_uniform(uniform float16 a[]) {
-    return __streaming_load_uniform_half(a);
+    return __streaming_load_uniform_half((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying unsigned int streaming_load(uniform unsigned int a[]) {
-    return (unsigned int)__streaming_load_varying_i32(a);
+    return (unsigned int)__streaming_load_varying_i32((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying int streaming_load(uniform int a[]) {
-    return __streaming_load_varying_i32(a);
+    return __streaming_load_varying_i32((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform unsigned int streaming_load_uniform(uniform unsigned int a[]) {
-    return (unsigned int)__streaming_load_uniform_i32(a);
+    return (unsigned int)__streaming_load_uniform_i32((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform int streaming_load_uniform(uniform int a[]) {
-    return __streaming_load_uniform_i32(a);
+    return __streaming_load_uniform_i32((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying unsigned int64 streaming_load(uniform unsigned int64 a[]) {
-    return (unsigned int64)__streaming_load_varying_i64(a);
+    return (unsigned int64)__streaming_load_varying_i64((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying int64 streaming_load(uniform int64 a[]) {
-    return __streaming_load_varying_i64(a);
+    return __streaming_load_varying_i64((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform unsigned int64 streaming_load_uniform(uniform unsigned int64 a[]) {
-    return (unsigned int64)__streaming_load_uniform_i64(a);
+    return (unsigned int64)__streaming_load_uniform_i64((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform int64 streaming_load_uniform(uniform int64 a[]) {
-    return __streaming_load_uniform_i64(a);
+    return __streaming_load_uniform_i64((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying float streaming_load(uniform float a[]) {
-    return __streaming_load_varying_float(a);
+    return __streaming_load_varying_float((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform float streaming_load_uniform(uniform float a[]) {
-    return __streaming_load_uniform_float(a);
+    return __streaming_load_uniform_float((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline varying double streaming_load(uniform double a[]) {
-    return __streaming_load_varying_double(a);
+    return __streaming_load_varying_double((uniform int8 * uniform) a);
 }
 
 __declspec(safe, cost1) static inline uniform double streaming_load_uniform(uniform double a[]) {
-    return __streaming_load_uniform_double(a);
+    return __streaming_load_uniform_double((uniform int8 * uniform) a);
 }
 
 ///////////////////////////////////////////////////////////////////////////
@@ -1897,11 +1907,11 @@ static inline void memory_barrier() { __memory_barrier(); }
 
 #define DEFINE_ATOMIC_OP(TA, TB, OPA, OPB, MASKTYPE, TC)                                                               \
     static inline TA atomic_##OPA##_global(uniform TA *uniform ptr, TA value) {                                        \
-        TA ret = __atomic_##OPB##_##TB##_global(ptr, value, (MASKTYPE)__mask);                                         \
+        TA ret = __atomic_##OPB##_##TB##_global((uniform int8 * uniform) ptr, value, (MASKTYPE)__mask);                \
         return ret;                                                                                                    \
     }                                                                                                                  \
     static inline uniform TA atomic_##OPA##_global(uniform TA *uniform ptr, uniform TA value) {                        \
-        uniform TA ret = __atomic_##OPB##_uniform_##TB##_global(ptr, value);                                           \
+        uniform TA ret = __atomic_##OPB##_uniform_##TB##_global((uniform int8 * uniform) ptr, value);                  \
         return ret;                                                                                                    \
     }                                                                                                                  \
     static inline TA atomic_##OPA##_global(uniform TA *varying ptr, TA value) {                                        \
@@ -1909,7 +1919,7 @@ static inline void memory_barrier() { __memory_barrier(); }
         ptrArray[programIndex] = ptr;                                                                                  \
         TA ret;                                                                                                        \
         foreach_active(i) {                                                                                            \
-            uniform TA *uniform p = ptrArray[i];                                                                       \
+            uniform int8 *uniform p = (uniform int8 * uniform) ptrArray[i];                                            \
             uniform TA v = extract(value, i);                                                                          \
             uniform TA r = __atomic_##OPB##_uniform_##TB##_global(p, v);                                               \
             ret = insert(ret, i, r);                                                                                   \
@@ -1930,7 +1940,7 @@ static inline void memory_barrier() { __memory_barrier(); }
         for (; i < programCount; ++i) {                                                                                \
             if ((mask & (1ull << i)) == 0)                                                                             \
                 continue;                                                                                              \
-            memVal = __atomic_swap_uniform_##TB##_global(ptr, extract(value, i));                                      \
+            memVal = __atomic_swap_uniform_##TB##_global((uniform int8 * uniform) ptr, extract(value, i));             \
             lastSwap = i;                                                                                              \
             break;                                                                                                     \
         }                                                                                                              \
@@ -1951,7 +1961,7 @@ static inline void memory_barrier() { __memory_barrier(); }
         return ret[programIndex];                                                                                      \
     }                                                                                                                  \
     static inline uniform TA atomic_swap_global(uniform TA *uniform ptr, uniform TA value) {                           \
-        uniform TA ret = __atomic_swap_uniform_##TB##_global(ptr, value);                                              \
+        uniform TA ret = __atomic_swap_uniform_##TB##_global((uniform int8 * uniform) ptr, value);                     \
         return ret;                                                                                                    \
     }                                                                                                                  \
     static inline TA atomic_swap_global(uniform TA *varying ptr, TA value) {                                           \
@@ -1959,7 +1969,7 @@ static inline void memory_barrier() { __memory_barrier(); }
         ptrArray[programIndex] = ptr;                                                                                  \
         TA ret;                                                                                                        \
         foreach_active(i) {                                                                                            \
-            uniform TA *uniform p = ptrArray[i];                                                                       \
+            uniform int8 *uniform p = (uniform int8 * uniform) ptrArray[i];                                            \
             uniform TA v = extract(value, i);                                                                          \
             uniform TA r = __atomic_swap_uniform_##TB##_global(p, v);                                                  \
             ret = insert(ret, i, r);                                                                                   \
@@ -1972,11 +1982,11 @@ static inline void memory_barrier() { __memory_barrier(); }
         uniform TA oneval = reduce_##OPA(value);                                                                       \
         TA ret;                                                                                                        \
         if (lanemask() != 0)                                                                                           \
-            ret = __atomic_##OPB##_uniform_##TB##_global(ptr, oneval);                                                 \
+            ret = __atomic_##OPB##_uniform_##TB##_global((uniform int8 * uniform) ptr, oneval);                        \
         return ret;                                                                                                    \
     }                                                                                                                  \
     static inline uniform TA atomic_##OPA##_global(uniform TA *uniform ptr, uniform TA value) {                        \
-        uniform TA ret = __atomic_##OPB##_uniform_##TB##_global(ptr, value);                                           \
+        uniform TA ret = __atomic_##OPB##_uniform_##TB##_global((uniform int8 * uniform) ptr, value);                  \
         return ret;                                                                                                    \
     }                                                                                                                  \
     static inline TA atomic_##OPA##_global(uniform TA *varying ptr, TA value) {                                        \
@@ -1984,7 +1994,7 @@ static inline void memory_barrier() { __memory_barrier(); }
         ptrArray[programIndex] = ptr;                                                                                  \
         TA ret;                                                                                                        \
         foreach_active(i) {                                                                                            \
-            uniform TA *uniform p = ptrArray[i];                                                                       \
+            uniform int8 *uniform p = (uniform int8 * uniform) ptrArray[i];                                            \
             uniform TA v = extract(value, i);                                                                          \
             uniform TA r = __atomic_##OPB##_uniform_##TB##_global(p, v);                                               \
             ret = insert(ret, i, r);                                                                                   \
@@ -2043,11 +2053,13 @@ DEFINE_ATOMIC_SWAP(double, double, IntMaskType, int64)
 #define ATOMIC_DECL_CMPXCHG(TA, TB, MASKTYPE, TC)                                                                      \
     static inline uniform TA atomic_compare_exchange_global(uniform TA *uniform ptr, uniform TA oldval,                \
                                                             uniform TA newval) {                                       \
-        uniform TA ret = __atomic_compare_exchange_uniform_##TB##_global(ptr, oldval, newval);                         \
+        uniform TA ret =                                                                                               \
+            __atomic_compare_exchange_uniform_##TB##_global((uniform int8 * uniform) ptr, oldval, newval);             \
         return ret;                                                                                                    \
     }                                                                                                                  \
     static inline TA atomic_compare_exchange_global(uniform TA *uniform ptr, TA oldval, TA newval) {                   \
-        TA ret = __atomic_compare_exchange_##TB##_global(ptr, oldval, newval, (MASKTYPE)__mask);                       \
+        TA ret =                                                                                                       \
+            __atomic_compare_exchange_##TB##_global((uniform int8 * uniform) ptr, oldval, newval, (MASKTYPE)__mask);   \
         return ret;                                                                                                    \
     }                                                                                                                  \
     static inline TA atomic_compare_exchange_global(uniform TA *varying ptr, TA oldval, TA newval) {                   \
@@ -2055,8 +2067,8 @@ DEFINE_ATOMIC_SWAP(double, double, IntMaskType, int64)
         ptrArray[programIndex] = ptr;                                                                                  \
         TA ret;                                                                                                        \
         foreach_active(i) {                                                                                            \
-            uniform TA r =                                                                                             \
-                __atomic_compare_exchange_uniform_##TB##_global(ptrArray[i], extract(oldval, i), extract(newval, i));  \
+            uniform TA r = __atomic_compare_exchange_uniform_##TB##_global((uniform int8 * uniform) ptrArray[i],       \
+                                                                           extract(oldval, i), extract(newval, i));    \
             ret = insert(ret, i, r);                                                                                   \
         }                                                                                                              \
         return ret;                                                                                                    \
